<template lang="pug">
div
	q-breadcrumbs(gutter="sm").q-mb-lg
		q-breadcrumbs-el(icon="home" to="/")
		q-breadcrumbs-el(label="Кухня" to="/kitchen")
		q-breadcrumbs-el(label="Меню" to="/kitchen/menu")
		q-breadcrumbs-el(:label="newItem ? 'Новое меню' : 'Редактирование меню'")

	.inner.q-py-md
		q-form.q-gutter-md(@submit="onSubmit")
			ui-input-date(
				v-model:from="item.start",
				v-model:to="item.end",
				label="Даты",
				range
				required,
				:disable="!newItem"
				:loading="loading"
				)

			collection-menu-range(
				v-model="item.dayMenus"
				:dates="dates"
			)

			q-btn(
				:label="newItem ? 'Добавить меню' : 'Сохранить меню'",
				type="submit",
				color="primary"
				:loading="loading"
			)


</template>

<script lang="ts">
	import { computed, defineComponent, onMounted, ref } from 'vue'
	import { mapWritableState } from 'pinia'
	import { IMenu } from '@/plugins/utils/types'
	import { useRouter } from 'vue-router'
	import UiInputDate from '@/components/ui/UiInputDate.vue'
	import CollectionMenuRange from '@/pages/kitchen/components/CollectionMenuRange.vue'
	import { useKitchenMenuStore } from '@/pages/kitchen/children/menu/store'
	import { useQuasar } from 'quasar'
	import moment from '@/plugins/moment'

	export default defineComponent({
		name: 'PageKitchenDishesItem',

		props: ['id'],

		components: {
			UiInputDate,
			CollectionMenuRange,
		},

		setup(props) {
			const $q = useQuasar()
			const newItem = ref(props.id === undefined)
			const store = useKitchenMenuStore()
			const router = useRouter()

			onMounted(() => {
				store.getMenuById(props.id)
			})

			const dates = computed(() => {
				const dateStart = moment(store.item.start, 'DD.MM.YYYY')
				const dateEnd = moment(store.item.end, 'DD.MM.YYYY')
				if (dateStart.isValid() && dateEnd.isValid()) {
					return Array.from(moment.range(dateStart, dateEnd).by('day')).map((d) => d.format('DD.MM.YYYY'))
				}
				return []
			})

			return {
				newItem,
				dates,
				loading: computed(() => store.loading),
				async onSubmit() {
					const { id } = (await store.saveMenuItem()) as unknown as IMenu
					await router.push(`/kitchen/menu/${id}`)
					$q.notify({
						color: 'positive',
						message: newItem.value ? 'Новое меню добавлено' : 'Изменения сохранены',
					})
				},
			}
		},

		computed: {
			...mapWritableState(useKitchenMenuStore, {
				item: 'item',
			}),
		},
	})
</script>
